/* als1r3.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int als1r3_c(real *b, real *c__, integer *m, integer *n,
        real *q, real *f, real *u, real *h__, real *v, real *w, real *w1)
{
    /* Initialized data */

    static real zero = 0.f;

    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer i__, j, k, l;
    static real r__, s, t;
    static integer l1;
    static real r1, r2, t1, t2, s1, s2, s3, s5;

/* *********************************************** */
/*        (D'*D+Q*E)*U=D'*F         */
/*        .   */
/* *********************************************** */
    /* Parameter adjustments */
    --f;
    --w1;
    --w;
    --v;
    --u;
    --c__;
    --b;
    --h__;

    /* Function Body */
    if (*m < *n || *n <= 2 || *q < zero) {
        return 0;
    }
    s = zero;
    l = *n + 1;
L10:
    --l;
    r__ = c__[l - 1];
    if (b[l] == s && r__ == s && l > 3) {
        goto L10;
    }
    l1 = l + 1;
    if ((i__1 = l - *m) < 0) {
        goto L11;
    } else if (i__1 == 0) {
        goto L13;
    } else {
        goto L20;
    }
L11:
    i__1 = *m;
    for (i__ = l1; i__ <= i__1; ++i__) {
        t1 = f[i__];
/* L12: */
        s += t1 * t1;
    }
L13:
    t = b[1];
/* Computing MAX */
    r__1 = (real)sqrt(*q + t * t), r__2 = abs(t);
    r__ = max(r__1,r__2);
    v[1] = r__;
    t2 = c__[1];
    r2 = t2 * (t / r__);
    w[1] = r2;
    s2 = f[1];
    r1 = t * s2 / r__;
    u[1] = r1;
    s5 = s2 * s2;
    i__1 = l;
    for (i__ = 2; i__ <= i__1; ++i__) {
        t = b[i__];
        t1 = t2;
        t2 = c__[i__];
        s1 = s2;
        s2 = f[i__];
/* Computing MAX */
        r__1 = zero, r__2 = (t1 - r2) * (t1 + r2);
        r__ = max(r__1,r__2);
/* Computing MAX */
        r__1 = (real)sqrt(t * t + r__ + *q), r__2 = abs(t);
        r__ = max(r__1,r__2);
        r1 = (t * s2 + t1 * s1 - r1 * r2) / r__;
        u[i__] = r1;
        v[i__] = r__;
        r2 = t2 * (t / r__);
        w[i__] = r2;
/* L14: */
        s5 += s2 * s2;
    }
    r2 = (real)sqrt(*q);
    if (l1 > *n) {
        goto L16;
    }
    i__1 = *n;
    for (i__ = l1; i__ <= i__1; ++i__) {
        u[i__] = zero;
        v[i__] = r2;
        w[i__] = zero;
/* L15: */
        w1[i__] = zero;
    }
L16:
    r__ = r1 / r__;
    u[l] = r__;
    r2 = r__ * t - s2;
    s1 = r2 * r2;
    s3 = r__ * r__;
    i__1 = l;
    for (i__ = 2; i__ <= i__1; ++i__) {
        j = l1 - i__;
        r1 = r__;
        r__ = (u[j] - r__ * w[j]) / v[j];
        u[j] = r__;
        r2 = r__ * b[j] + r1 * c__[j];
        r2 -= f[j];
        s1 += r2 * r2;
/* L17: */
        s3 += r__ * r__;
    }
    r__ = *q * r__ / v[1];
    w1[1] = r__;
    i__1 = l;
    for (k = 2; k <= i__1; ++k) {
        r__ = (*q * u[k] - r__ * w[k - 1]) / v[k];
/* L18: */
        w1[k] = r__;
    }
    r__ /= v[l];
    w1[l] = r__;
    s2 = r__ * r__;
    i__1 = l;
    for (i__ = 2; i__ <= i__1; ++i__) {
        j = l1 - i__;
        r__ = (w1[j] - r__ * w[j]) / v[j];
        w1[j] = r__;
        s2 += r__ * r__;
        r1 = (w1[j + 1] + u[j + 1]) * w[j];
/* L19: */
    }
/* ------------------------------------------------ */
/*        :    */
/*      H(1)  = !!D*U-F!!   -   .            */
/*      H(2)  = Q*!!!U'!!!  -   .   */
/*      H(3)  = !!!U!!!     -   . .  */
/*      H(4)  = !!D*U-F!!**2+Q*!!!U!!!**2           */
/*      H(5)  = Q      -    .  */
/*      H(6)  = !!D*U-F!!/!!F!! -  .  */
/* ------------------------------------------------ */
    h__[1] = (real)sqrt(s1 + s);
    h__[2] = (real)sqrt(s2);
    h__[3] = (real)sqrt(s3);
    h__[4] = s1 + s + *q * s3;
    h__[5] = *q;
    h__[6] = h__[1] / (real)sqrt(s5 + s);
L20:
    return 0;
} /* als1r3_c */
