/* als1r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int als1r_c(real *a, real *u, real *f, integer *m, integer *n,
         real *eps, real *h__, real *w, integer *l)
{
    /* System generated locals */
    integer a_dim1, a_offset, w_dim1, w_offset, i__1;
    real r__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static real rmin, rmin1;
    static integer i__;
    static real q, r__, s;
    extern /* Subroutine */ int als1r1_c(real *, integer *, integer *, real *,
            real *),
            als1r2_c(real *, integer *, integer *, real *),
            als1r3_c(real *, real *, integer *, integer *, real *, real *,
                     real *, real *, real *, real *, real *),
            als1r4_c(real *, integer *, integer *, real *);
    static integer niter, iexit;
    static real f1, h1, hh, qq, rr, sr;
    static integer nit;


#define w_ref(a_1,a_2) w[(a_2)*w_dim1 + a_1]

    /* Parameter adjustments */
    --f;
    w_dim1 = *n;
    w_offset = w_dim1 + 1;
    w -= w_offset;
    --u;
    a_dim1 = *m;
    a_offset = a_dim1 + 1;
    a -= a_offset;
    --h__;

    /* Function Body */
    rmin1 = 1.f;
    switch (*l) {
        case 1:  goto L1;
        case 2:  goto L3;
        case 3:  goto L2;
    }
L1:
    rmin = rmin1;
    rmin1 = rmin / 2.f;
    if (rmin1 > 0.f) {
        goto L1;
    }
    als1r1_c(&a[a_offset], m, n, &w[w_offset], &w_ref(1, 2));
    w_ref(*n, 2) = rmin;
L2:
    als1r2_c(&a[a_offset], m, n, &f[1]);
L3:
    rmin = w_ref(*n, 2);
    rmin1 = rmin * 16;
    f1 = f[1];
    r__ = f1 * f1;
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        f1 = f[i__];
/* L4: */
        r__ += f1 * f1;
    }
    sr = (real)sqrt(r__);
/* Computing 2nd power */
    r__1 = f[1] * w_ref(1, 1) / sr;
    s = r__1 * r__1;
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        f1 = f[i__];
/* L5: */
/* Computing 2nd power */
        r__1 = (w_ref(i__, 1) * f1 + w_ref(i__ - 1, 2) * f[i__ - 1]) / sr;
        s += r__1 * r__1;
    }
    rr = sr * *eps;
    h__[1] = sr;
    h__[2] = 0.f;
    h__[3] = 0.f;
    h__[4] = r__;
    h__[5] = 1e20f;
    h__[6] = 1.f;
    h__[7] = 0.f;
    niter = 0;
    nit = 0;
    iexit = -1;
    hh = sr;
    qq = h__[5];
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L6: */
        u[i__] = 0.f;
    }
    if (*eps >= 1.f) {
        return 0;
    }
    q = *eps / (1.f - *eps) * s;
    if (q == 0.f) {
        q = rmin;
    }
L7:
    als1r3_c(&w[w_offset], &w_ref(1, 2), m, n, &q, &f[1], &u[1], &h__[1],
            &w_ref(1, 3), &w_ref(1, 4), &w_ref(1, 5));
    h1 = h__[1];
    ++niter;
    if (iexit == 1) {
        goto L10;
    }
    if (hh >= h1) {
        goto L8;
    }
    iexit = 1;
    q = qq;
    goto L7;
L8:
    if (rr * 1.001f >= h1) {
        goto L10;
    }
    if (q <= rmin1) {
        goto L10;
    }
    hh = h1;
    qq = q;
    s = 0.f;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L9: */
        s += u[i__] * q * w_ref(i__, 5);
    }
    if (s == 0.f) {
        s = rmin1 * 4.f;
    }
    r__ = (h1 / rr - 1.f) * h1 * (h1 / s);
    if (r__ <= .5f) {
        ++nit;
    }
    if (r__ <= .5f && h__[6] >= 10.f && nit > 5) {
        r__ = 1.f;
    }
    q /= r__ + 1.f;
    if (q == 0.f) {
        q = rmin;
    }
    goto L7;
L10:
    als1r4_c(&a[a_offset], m, n, &u[1]);
    h__[7] = (real) niter;
    w_ref(*n, 2) = rmin;
    return 0;
} /* als1r_c */

#undef w_ref
